org.apache.commons.io.input

## Class ReadAheadInputStream.Builder

- java.lang.Object
- - org.apache.commons.io.build.AbstractSupplier<T,B>
  - - org.apache.commons.io.build.AbstractOriginSupplier<T,B>
    - - org.apache.commons.io.build.AbstractStreamBuilder<ReadAheadInputStream,ReadAheadInputStream.Builder>
      - - org.apache.commons.io.input.ReadAheadInputStream.Builder

- All Implemented Interfaces:
    IOSupplier<ReadAheadInputStream>
  Enclosing class:
    ReadAheadInputStream

      public static class ReadAheadInputStream.Builder
      extends AbstractStreamBuilder<ReadAheadInputStream,ReadAheadInputStream.Builder>

  Builds a new `ReadAheadInputStream`.

  For example:

       ReadAheadInputStream s = ReadAheadInputStream.builder()
         .setPath(path)
         .setExecutorService(Executors.newSingleThreadExecutor(ReadAheadInputStream::newThread))
         .get();

  See Also:
    `get()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Builder()` Constructs a new builder of `ReadAheadInputStream`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ReadAheadInputStream` | `get()` Builds a new `ReadAheadInputStream`.
    `ReadAheadInputStream.Builder` | `setExecutorService(ExecutorService executorService)` Sets the executor service for the read-ahead thread.

    - ### Methods inherited from class org.apache.commons.io.build.AbstractStreamBuilder

      `getBufferSize, getBufferSizeDefault, getCharSequence, getCharset, getCharsetDefault, getFile, getInputStream, getOpenOptions, getOutputStream, getPath, getRandomAccessFile, getReader, getWriter, setBufferSize, setBufferSize, setBufferSizeChecker, setBufferSizeDefault, setBufferSizeMax, setCharset, setCharset, setCharsetDefault, setOpenOptions`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractOriginSupplier

      `checkOrigin, getOrigin, hasOrigin, newByteArrayOrigin, newCharSequenceOrigin, newFileOrigin, newFileOrigin, newInputStreamOrigin, newOutputStreamOrigin, newPathOrigin, newPathOrigin, newRandomAccessFileOrigin, newRandomAccessFileOrigin, newReaderOrigin, newURIOrigin, newWriterOrigin, setByteArray, setCharSequence, setFile, setFile, setInputStream, setOrigin, setOutputStream, setPath, setPath, setRandomAccessFile, setRandomAccessFile, setReader, setURI, setWriter`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractSupplier

      `asThis`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.function.IOSupplier

      `asSupplier, getUnchecked`

- - ### Constructor Detail

    - #### Builder

          public Builder()

      Constructs a new builder of `ReadAheadInputStream`.

  - ### Method Detail

    - #### get

          public ReadAheadInputStream get()
                                   throws IOException

      Builds a new `ReadAheadInputStream`.

      You must set an aspect that supports `AbstractStreamBuilder.getInputStream()`, otherwise, this method throws an exception.

      This builder uses the following aspects:

      - `AbstractStreamBuilder.getInputStream()` gets the target aspect.
      - `AbstractStreamBuilder.getBufferSize()`
      - `ExecutorService`
      Returns:
        a new instance.
      Throws:
        `IllegalStateException` - if the `origin` is `null`.
        `UnsupportedOperationException` - if the origin cannot be converted to an `InputStream`.
        `IOException` - if an I/O error occurs converting to an `InputStream` using `AbstractStreamBuilder.getInputStream()`.
      See Also:
        `AbstractStreamBuilder.getInputStream()`, `AbstractStreamBuilder.getBufferSize()`, `IOSupplier.getUnchecked()`

    - #### setExecutorService

          public ReadAheadInputStream.Builder setExecutorService(ExecutorService executorService)

      Sets the executor service for the read-ahead thread.
      Parameters:
        `executorService` - the executor service for the read-ahead thread.
      Returns:
        `this` instance.